---
title: CanvasRenderingContext2D.beginPath()
slug: Web/API/CanvasRenderingContext2D/beginPath
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Method
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.beginPath()</code></strong> method of the Canvas 2D API starts a new path by emptying the list of sub-paths. Call this method when you want to create a new path.</p>

<div class="note">
<p><strong>Note:</strong> To create a new sub-path, i.e., one matching the current canvas state, you can use {{domxref("CanvasRenderingContext2D.moveTo()")}}.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <em>ctx</em>.beginPath();
</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Creating_distinct_paths">Creating distinct paths</h3>

<p>This example creates two paths, each of which contains a single line.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<p>The <code>beginPath()</code> method is called before beginning each line, so that they may be drawn with different colors.</p>

<pre class="brush: js; highlight:[5,12]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

// First path
ctx.beginPath();
ctx.strokeStyle = 'blue';
ctx.moveTo(20, 20);
ctx.lineTo(200, 20);
ctx.stroke();

// Second path
ctx.beginPath();
ctx.strokeStyle = 'green';
ctx.moveTo(20, 20);
ctx.lineTo(120, 120);
ctx.stroke();
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Creating_distinct_paths', 700, 180) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-beginpath", "CanvasRenderingContext2D.beginPath")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.beginPath")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this method: {{domxref("CanvasRenderingContext2D")}}</li>
 <li>{{domxref("CanvasRenderingContext2D.closePath()")}}</li>
</ul>
